#include <unistd.h>
#include <fcntl.h>

int chsize(int fd,long size) {
  long pos = lseek(fd,0L,2);	/* current size of file */
  if (size < pos) {
#ifndef F_FREESP
    return -1;
#else
    struct flock f;
    f.l_whence = 0;
    f.l_start = size;
    f.l_len = 0L;
    return fcntl(fd,F_FREESP,&f);
#endif
  }
  if (size > pos) {
    char c = 0;
    if (lseek(fd,size - 1,0) != size - 1) return -1;
    if (write(fd,&c,1) != 1) return -1;
  }
  return 0;
}

#ifdef DEBUG
main(int argc,char **argv) {
  int fd;
  if (argc != 3) {
    puts("Usage:\tchsize file size");
    return 1;
  }
  fd = open(argv[1],O_WRONLY);
  if (fd == -1) {
    perror(argv[1]);
    return 1;
  }
  if (chsize(fd,atol(argv[2]))) {
    perror("chsize");
    return 1;
  }
  return 0;
}
#endif
