/* date.c 1.12 11/22/85 */
/* date functions - alb - 10/27/84 */

#include <date.h>

DATE mdy_to_doc(d) /* calc day of century */
  struct mmddyy d;
{
	register int dyyr;
	if (d.yy < 50)				/* cludge to handle > 2000 */
		d.yy += 100;
	dyyr = d.dd + ((d.mm * 275)/9)-30;	/* day of year conversion */
	if (d.mm > 2) {			/* handle leapyears */
		dyyr--;
		if (d.yy % 4)
			dyyr--;
	}
	return (dyyr+((long)(d.yy - 1)*1461)/4);	/* day of century */
}

struct mmddyy doc_to_mdy(doc) /* calc mmddyy from doc */
  DATE doc;
{
  struct mmddyy mdy;	/* temporary result */
	register int dyyr; 
	register int leapyear = 2;		/* not leapyear adj = 2 */
	mdy.yy = (doc - doc/1461 +364)/365;	/* calculate year */
	dyyr = doc - ((long)(mdy.yy-1)*1461)/4;	/* day of year conversion */
	if (mdy.yy % 4 == 0)			/* is this a leapyear? */
		leapyear = 1;			/* yes - reset adj to 1 */
	if (dyyr > 59 && (dyyr > 60 || leapyear == 2))
		dyyr += leapyear;		/* correct for leapyear */
	mdy.mm = (269 + dyyr * 9) / 275;	/* calculate month */
	mdy.dd = dyyr + 30 - 275 * mdy.mm/9;	/* calc day of month */
	if (mdy.yy >99)				/* cludge for > 2000 */
		mdy.yy -= 100;
	return (mdy);
}
