/*
	date.h
	The BMS (DATE) type is the number of days since 12/31/69.
	The BMS (JULDAY) type is the number of days since ???? B.C.
*/

#ifndef zeroD
#define getdate SYSgetdate
#include <time.h>
#undef getdate

typedef unsigned short DATE;
typedef char FDATE[2];
/* some routines using this expect yy to be 2 digits, and some expect 4  */
struct mmddyy {	
	short mm;
	short dd;
	short yy;
};
struct mdy {
  short mo,dy,yr;	/* for old programs (if any) */
};

#define zeroD		((DATE)0) 
#define MAXDATE		((DATE)-1)
#define stD(d,f)	stshort(d,f)
#define ldD(f)		(DATE)ldshort(f)

extern DATE mdy_to_doc(/**/ struct mmddyy /**/),
	    sysD(/**/ void /**/),
	    caltoD(/**/ long /**/),
	    stoD(/**/ const char * /**/);
extern long Dtocal(/**/ int /**/);
extern struct mmddyy doc_to_mdy(/**/ int /**/);
extern char *datestr(/**/ int,char *,int /**/);
extern void decode(/**/ struct mmddyy *,long /**/);
extern long encode(/**/ struct mmddyy /**/);
#define ltoD(a)         caltoD(a)
#define Dtocal(d)	encode(doc_to_mdy(d))

typedef long JULDAY;
typedef char FJULDAY[4];

#define zeroJ		((JULDAY)0) 
#define MAXJULDAY	((JULDAY)-1)
#define stJ(d,f)	stlong(d,f)
#define ldJ(f)		ldlong(f)

DATE JtoD(JULDAY);	/* JULDAY --> DATE */
JULDAY DtoJ(DATE);	/* DATE --> JULDAY */
JULDAY julian(const struct mmddyy *);
void julmdy(JULDAY, struct mmddyy *);
JULDAY stoJ(const char *);

JULDAY timeJ(time_t);
time_t stoT(const char *);

void tm_mask(const struct tm *,const char *,char *);
void timemask(time_t,const char *,char *);

#endif
