/* convert ebcdic to ascii */

#include "ebcdic.h"

#define ERR 0177	/* translate untranslatable chars to this */

const char etoa[256] = {

/*	0    1    2    3    4    5    6    7	*/
/*00*/ 000, 001, 002, 003, ERR, 011, ERR,0177,	/* 00 */
/*01*/ ERR, ERR, ERR, 013, 014, 015, 016, 017,	/* 08 */
/*02*/ 020, 021, 022, ERR, ERR, 012, 010, ERR,	/* 10 */
/*03*/ 030, 031, ERR, ERR, 034, 035, 036, 037,	/* 18 */
/*04*/ ERR, ERR, 034, ERR, ERR, 012, 027, 033,	/* 20 */
/*05*/ ERR, ERR, ERR, ERR, ERR, 005, 006, 007,	/* 28 */
/*06*/ ERR, ERR, 026, ERR, ERR, 036, ERR, 004,	/* 30 */
/*07*/ ERR, ERR, ERR, ERR, 024, 025, ERR, 032,	/* 38 */
/*10*/ ' ', ERR, ERR, ERR, ERR, ERR, ERR, ERR,	/* 40 */
/*11*/ ERR, ERR,'\\', '.', '<', '(', '+', ']',	/* 48 */
/*12*/ '&', ERR, ERR, ERR, ERR, ERR, ERR, ERR,	/* 50 */
/*13*/ ERR, ERR, '!', '$', '*', ')', ':', '^',	/* 58 */
/*14*/ '-', '/', ERR, ERR, ERR, ERR, ERR, ERR,	/* 60 */
/*15*/ ERR, ERR, '|', ',', '%', '_', '>', '?',	/* 68 */
/*16*/ ERR, ERR, ERR, ERR, ERR, ERR, ERR, ERR,	/* 70 */
/*17*/ ERR, '`', ':', '#', '@','\'', '=', '"',	/* 78 */
/*20*/ ERR, 'a', 'b', 'c', 'd', 'e', 'f', 'g',	/* 80 */
/*21*/ 'h', 'i', ERR, ERR, ERR, ERR, ERR, ERR,	/* 88 */
/*22*/ ERR, 'j', 'k', 'l', 'm', 'n', 'o', 'p',	/* 90 */
/*23*/ 'q', 'r', ERR, ERR, ERR, ERR, ERR, ERR,	/* 98 */
/*24*/ ERR, '~', 's', 't', 'u', 'v', 'w', 'x',	/* a0 */
/*25*/ 'y', 'z', ERR, ERR, ERR, '[', ERR, ERR,	/* a8 */
/*26*/ ERR, ERR, ERR, ERR, ERR, ERR, ERR, ERR,	/* b0 */
/*27*/ ERR, ERR, '[', ']', ERR, ']', ERR, ERR,	/* b8 */
/*30*/ '{', 'A', 'B', 'C', 'D', 'E', 'F', 'G',	/* c0 */
/*31*/ 'H', 'I', ERR, ERR, ERR, ERR, ERR, ERR,	/* c8 */
/*32*/ '}', 'J', 'K', 'L', 'M', 'N', 'O', 'P',	/* d0 */
/*33*/ 'Q', 'R', ERR, ERR, ERR, ERR, ERR, ERR,	/* d8 */
/*34*/'\\', ERR, 'S', 'T', 'U', 'V', 'W', 'X',	/* e0 */
/*35*/ 'Y', 'Z', ERR, ERR, ERR, ERR, ERR, ERR,	/* e8 */
/*36*/ '0', '1', '2', '3', '4', '5', '6', '7',	/* f0 */
/*37*/ '8', '9', ERR, ERR, ERR, ERR, ERR, ERR	/* f8 */

};
