/*	This module modifies the working of execvp() & execlp() slightly.
  The unix version searches the PATH only if the program name contains
  no slashes.  This version always searches the PATH unless the program name
  *begins* with a slash.  -- sdg */

/* P.S. - execlp() has a naughty implementation which may need to be fixed
	for strange stack disciplines.  There either needs to be a maximum
	number of args that can be passed or va_start(), va_end() must be
	able to be called twice.  -- sdg */

#include <stdlib.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <port.h>

#define		MAXPATHLEN	128

int execvp(const char *name,char * const *argv) {
  register char *np, *path;
  char filename[MAXPATHLEN+1];
  if ( *name == '/' || !(path = getenv("PATH"))) path = "";
  for (;;) {
	if (!(np = strchr(path, ':')))
		np = path + strlen(path);	/* point to end str */
	if (np - path <= 1)			/* %% */
		(void) strcpy(filename, name);
	else {
		(void) strncpy(filename, path, np - path);
		filename[np - path] = '/';
		(void) strcpy(filename + (np - path) + 1, name);
	}
	execv(filename,argv);
#ifdef m68k
	if (errno == ENOEXEC) {	/* exec shell procedure */
	  const char *save;
	  path = getenv("SHELL");
	  if (!path) path = "/bin/sh";
	  save = *--argv;
	  argv[0] = path;	/* we hope this won't mess up since exec */
	  argv[1] = filename;
	  execv(path,argv);
	  *argv = save;
	  return -1;
	}
#endif
	if (!*np) return -1;	/* can't find name */
	path = np + 1;
  }
}

#include <stdarg.h>

int execlp(const char *name, MORE) {
  enum { MAXARG = 512 };
  /*const*/ char *nargv[MAXARG + 1];
  int i = 0;
  va_list args;
  va_start(args,name);
  do
    nargv[i] = va_arg(args,const char *);
  while (nargv[i++] && i < MAXARG);
  va_end(args);
  nargv[i] = 0;
  return execvp(name,nargv);	/* non-portable, but works mostly */
}
