/* convert money to and from floating format
 * $Log$
 * Revision 1.1.1.2  2003/10/05 04:31:43  stuart
 * BMS library
 *
 * Revision 1.2  2003/10/05 04:31:28  stuart
 * isnan test failing on Intel
 *
 */

#include <money.h>
#include <math.h>

#define	WORD	((long)(unsigned short)~0 + 1)

double Mtof(const MONEY *a) {	/* convert MONEY to floating point format */
  return (double)WORD*a->high + a->low;
}

#define TRUNC -1	/* truncate toward -inf */
//#define TRUNC 0	/* truncate toward 0 */

#ifdef _AIX
#define isnan(a) \
  ((*(unsigned short *)&a & 0x7FF0) == 0x7FF0)
#endif

MONEY ftoM(double a) {
  MONEY res;
  if (isnan(a)) {
    res = zeroM;
    res.high ^= 0x80000000L;
  }
  else {
    double low;
    char neg = 0;
    if (a<0) {	/* modf is broken for negative numbers on some systems */
      neg = 1;
      a = -a;
    }
    low = WORD*modf(a/WORD,&a);
    res.high = (long)a;
    (void)modf(low,&a);
    res.low = (unsigned short)a;
    if (neg) (void)mulM(&res,-1,TRUNC);
  }
  return res;
}
