/*
fndnam.c Revision:  1.5 as of 4/18/91
Copyright (c) 1988 Business Management Systems, Inc.
*/

#include <pwd.h> 
#include <string.h>

/* Returns a pointer to a static buffer containing the user's login name.
   The buffer will be null terminated and will be blank padded
   to at least 10 characters if need be.  A blank buffer is returned if
   the user's name isn't found.
*/
char *fndnam(uid)
  unsigned short uid;
{
  struct passwd *getpwuid(), *pd;
  static char buf[11];
  int l;

  memset(buf,' ',sizeof buf-1);		/* clear buffer */
  buf[sizeof buf-1] = '\0';		/* null terminate it */
  pd = getpwuid((int)uid);		/* get password structure */
  if (!pd) return buf;
  l = strlen(pd->pw_name);
  if (l > sizeof buf-1) return pd->pw_name;
  else memcpy(buf,pd->pw_name,l);
  return buf;
}
