/* $Log$
 * Revision 1.5  1995/01/09  20:37:45  stuart
 * handle years before 1601
 *
 */
#include <date.h>

#define	C4	146097L		/* days in four centuries */
#define C1	36524L		/* days in one century */
#define	Y4	1461		/* days in four years */

void julmdy(JULDAY jday,struct mmddyy *date) {
  int yorg = -4715;
  int leap = 0;
  if (jday == 0x7FFFFFFF) {
    date->mm = 99;
    date->dd = 99;
    date->yy = 9999;
    return;
  }
  if (jday >= 2305814) {	/* beginning 1 Jan 1601 */
    jday -= 2305507L;		/* origin 29 Feb 1600 AD */
    if (jday%C4<307) ++leap;
    jday -= jday/C4;
    if (jday%C1<307) --leap;
    jday += jday/C1;
    yorg = 1601;
  }
  else {
    if (jday > 2299160L)
      jday += 10;
    jday -= 59 - Y4;
  }
  if (jday%Y4<307) ++leap;
  jday -= jday/Y4;
  date->yy = (jday-307)/365;
  jday -= date->yy*365L;
  date->yy += yorg;
  if (jday>365) leap=2;	/* Feb 29 */
  jday += leap;
  date->mm = (jday*9-2485)/275;
  date->dd = jday-(date->mm*275)/9-276;
}

#ifdef DEBUG_MAIN
#include "julian.c"

int main(int argc,char **argv) {
  JULDAY beg,end;
  struct mmddyy mdy, mdy2;
  beg = atol(argv[1]);
  end = atol(argv[2]);
  for (mdy.yy = beg; mdy.yy <= end; ++mdy.yy) {
    JULDAY j;
    mdy.mm = 1;
    mdy.dd = 1;
    j = julian(&mdy);
    julmdy(j,&mdy2);
    printf("%d/%02d/%04d = %ld = %d/%02d/%04d\n",
	mdy.mm,mdy.dd,mdy.yy,j,mdy2.mm,mdy2.dd,mdy2.yy);
    mdy.mm = 3;
    j = julian(&mdy);
    julmdy(j,&mdy2);
    printf("%d/%02d/%04d = %ld = %d/%02d/%04d\n",
	mdy.mm,mdy.dd,mdy.yy,j,mdy2.mm,mdy2.dd,mdy2.yy);
    julmdy(--j,&mdy2);
    printf("%ld = %d/%02d/%04d\n",j,mdy2.mm,mdy2.dd,mdy2.yy);
    mdy.mm = 2;
    mdy.dd = 28;
    j = julian(&mdy);
    julmdy(j,&mdy2);
    printf("%d/%02d/%04d = %ld = %d/%02d/%04d\n",
	mdy.mm,mdy.dd,mdy.yy,j,mdy2.mm,mdy2.dd,mdy2.yy);
    mdy.mm = 12;
    mdy.dd = 31;
    j = julian(&mdy);
    julmdy(j,&mdy2);
    printf("%d/%02d/%04d = %ld = %d/%02d/%04d\n",
	mdy.mm,mdy.dd,mdy.yy,j,mdy2.mm,mdy2.dd,mdy2.yy);
  }
  return 0;
}
#endif
