static char what[] = "@(#)money.c	1.12";

#include <money.h>

#define WSIZ 16				/* bits in unsigned short */

MONEY *addM(a,b)	/* add two MONEY's */
  MONEY *a;
  const MONEY *b;
{
  register long low;
  a->low = (low = (long)a->low + b->low);
  a->high += b->high + (low >> WSIZ);
  return a;
}

MONEY *subM(a,b)
  MONEY *a;
  const MONEY *b;
{
  register long low;
  a->low = (low = (long)a->low - b->low);
  a->high -= b->high + (low < 0);
  return a;
}

int cmpM(a,b)	/* compare MONEY, return -1,0,1 */
  const MONEY *a, *b;
{
  MONEY v; v = *a;
  return sgnM(subM(&v,b));
}

int vcmpM(a,b) MONEY a,b;
{ return sgnM(subM(&a,&b)); }

MONEY vaddM(a,b) MONEY a,b;
{ return *addM(&a,&b); }

MONEY vsubM(a,b) MONEY a,b;
{ return *subM(&a,&b); }

/*
	A mathematical definition of remainder:
Dividend  divisor    Q * d   +  r = D
D = -203, d = 100,  -2 * 100 + -3 = -203
D = -203, d = -100,  2 * -100 + -3 = -203
D = 203, d = 100,    2 * 100 + 3 = 203
D = 203, d = -100,  -2 * -100 + 3 = 203
*/
int divM(nu,div)	/* divide MONEY by short, return remainder */
  register MONEY *nu; register short div;
{
  register unsigned long low;
  register char sign = 0, dsign = 0;
  if (nu->high < 0) {
    mulM(nu,-1,0);
    sign = 1;
  }
  if (div < 0) {
    div = -div;
    dsign = 1;
  }
  low = ((nu->high%div)<<WSIZ)+nu->low;
  nu->low = low/div;
  nu->high /= div;
  if (sign != dsign)
    mulM(nu,-1,0);
  if (sign)
    return -(low%div);
  return low%div;
}

int sgnM(nu)		/* return -1,0,1 to reflect sign of money */
  register const MONEY *nu;
{ return (nu->high==0L && nu->low==0) ? 0 : (nu->high < 0L) ? -1 : 1; }

int vsgnM(nu)
  MONEY nu;
{ return sgnM(&nu); }

MONEY ltoM(lval)	/* convert long to MONEY */
  long lval;
{
  MONEY temp;
  temp.low = lval;
  temp.high = (short)(lval >> WSIZ);
  return temp;
}

long Mtol(M)
  const MONEY *M;
{
  return (M->high << WSIZ) + M->low;
}
