/*
	money.h
*/

#ifndef mulmoney
typedef struct { long high; unsigned short low; } MONEY;
typedef char FMONEY[6];

/* map old names for functions */

#define	mulmoney(a,b,c)	mulM(a,b,c)
#define divmoney(a,b)	divM(a,b)
#define moneysgn(a)	sgnM(a)
#define ftomoney(a)	ftoM(a)
#define moneytof(a)	Mtof(a)

extern MONEY zeroM,nullM; /* special structures used for initialization */

extern MONEY *addM(MONEY *, const MONEY *),
	     *subM(MONEY *, const MONEY *), *mulM(MONEY *,int,int);
extern MONEY vaddM(MONEY,MONEY), vsubM(MONEY,MONEY),
	ltoM(long), ftoM(double), ldM(FMONEY);
extern MONEY ldnum(const char *,int);
extern void  stnum(MONEY,char *,int);
extern int divM(MONEY *,int), sgnM(const MONEY *), vsgnM(MONEY),
	cmpM(const MONEY *, const MONEY *), vcmpM(MONEY,MONEY);
extern double Mtof(const MONEY *);
extern long Mtol(const MONEY *);
extern char *stM(MONEY,FMONEY), signmethod(void);
#define faddM(a,b)	stM(vaddM(ldM(a),ldM(b)),a)
#define fsubM(a,b)	stM(vsubM(ldM(a),ldM(b)),a)
#define fcmpM(a,b)	blkcmpr((char *)(a),(char *)(b),sizeof(FMONEY))
#define fsgnM(a)	vsgnM(ldM(a))
#define frevM(a)	stM(vsubM(zeroM,ldM(a)),a)
extern FMONEY fzeroM;

extern char *pic(const MONEY *, const char *, char *);
extern char *picl(long, const char *, char *);
extern long stol(const char *, const char *, int);
extern MONEY *strtomny(const char *, const char *, MONEY *, int);
extern MONEY *FpicM(const FMONEY, const char *, char *);
#endif
