#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include "pathopen.h"

#define		MAXPATHLEN	256

int pathopen(name,mode,mask)
  const char *name;	/* search PATH for file name, return file descriptor */
  int mode,mask;	/* additional parms for open */
{
  register char *np, *path;
  int fd;
  size_t len;
  char filename[MAXPATHLEN+1];
  if (name == 0 || (len = strlen(name)) > MAXPATHLEN) return -1;
  if ( name[0] == '/' || !(path = getenv("PATH"))) path = "";
  for (;;) {
	if (!(np = strchr(path, ':')))
		np = path + strlen(path);	/* point to end str */
        int dlen = np - path;
	if (dlen <= 1)			/* %% */
		(void) strcpy(filename, name);
	else {
        	if (dlen + 1 + len > MAXPATHLEN) continue;
		(void) strncpy(filename, path, dlen);
		filename[dlen] = '/';
		(void) strcpy(filename + dlen + 1, name);
	}
	fd = open(filename,mode,mask);
	if (fd >= 0) return fd;
	if (*np == 0) break;	/* end of path */
	path = np + 1;
  }
  return -1;	/* can't find name */
}
