/* pic.c 1.2 2/19/85 Stuart & Jeff */

#include <stdlib.h>
#include <money.h>

char *picl(nu,mask,outptr)
  long nu;
  const char *mask;
  char *outptr;
{
  MONEY tmp;
  tmp = ltoM(nu);
  return pic(&tmp,mask,outptr);
}

#define	DECIMAL	0
#define	COMMA	1
#define LBRACK	2
#define RBRACK	3
#define CURR	4

char *pic(nu,mask,outptr)	/* format a number for output */

const MONEY *nu;		/* incoming number to format */
const char *mask;		/* formatting control mask */
char *outptr;			/* output buffer position */

{ 
  static char *spec;
  char	fill = ' ',		/* fill character */
	sign = '+';
  int masklen;			/* length of mask in bytes */
  register char *p;		/* current buffer position */
  register int c;		/* current character */
  char *start, *startd;		/* last & first digit pointers */
  MONEY num;

  if (!spec) if (!(spec=getenv("PIC"))) spec = ".,<>$";

  num = *nu;	/* copy of number */

  for (p=outptr; *mask ; *p++ = *mask++);	/* copy mask to buffer */
  masklen = p-outptr;				/* save mask length */
  
  if (moneysgn(nu)<0) 				/* find sign of number */
  { 
    sign = '-';
    mulmoney(&num,-1,0);			/* take absolute value */
  }

  /* find last digit, blank if positive, p -> end of mask field */

  while (--p>=outptr && (c = *p)!='#' && c!='Z' )
    if (sign == '+')				/* if positive */
    { 
      if (c!='+' && c!='%') *p = ' ';		/* blank all but +,% */
    }	
    else
    { 
      if (c=='+') *p = '-';	/* all but + unchanged if negative */
      if (c=='>') *p = spec[RBRACK]; 
    }

/* replace Z & # with digits, Z's replaced with blank instead of a leading
   zero except after (before since we are going backwards) the decimal */

  startd = start = ++p;
  while (p>outptr)
  { 
    c = *--p;
    if (c=='.')
    { 
      *p=spec[DECIMAL];
      if (startd!=start)
      { 
	register char *r1=startd;
	while (r1!=p)
	{ 
	  if ( *r1=='Z') *r1='0'; /* replace Z with 0 after decimal */
	  --r1; 
	}	
	startd = p;
      }
    }
    if (c==',') *p = spec[COMMA];
    if ( c=='#' || (c=='Z' && moneysgn(&num)) )
    { 
      *p = divmoney(&num,10)+'0'; 
      startd = p; 
    }
  }

  if (moneysgn(&num)) blkfilr(outptr,'*',masklen);	/* check overflow */

  if ((fill = *p)!='*') fill = ' ';	/* determine fill character */

/* insert floating character before first digit */

  { 
    register int floatc = fill;
    while (p<startd)
    { 
      if ((c = *p)=='$') floatc = spec[CURR];
      if (c=='+' || c==sign) floatc = sign;
      if (c=='<' && sign == '-') floatc = spec[LBRACK];
      *p++ = fill;
    }
    if (p>outptr && moneysgn(nu)) *--p = floatc;	/* insert floatc char */
  }
  return outptr;
}
