/*
	seteos.c - SET End Of String (block)

	Searchs a string backwards for the passed character, and 
	null terminates the string after the first non-matching character.

	If the first non-matching character happens to be last character in
	in the string, then that character is replaced with a null terminator.

	Returns the length of the new string. Note: you could end up with
	a string with a length equal to zero.
*/

int seteos(s,c,l)
  char *s;	/* block of characters */
  char c;	/* character to remove from end */ 
  int l;	/* length of s */
{
  char *e = s+l;	/* point to character after s */
  while (--l && *--e != c);
  *(s+l) = 0;	/* null terminate */
  return l;	/* return new length of string */
}
