#include <stdlib.h>
#include <string.h>
#include <process.h>

extern char **environ;

int spawnve(int mode,const char *path,
	const char * const *argv,const char * const *envp) {
  int pid,status;
  if (mode == P_OVERLAY)
    return execve(path,argv,envp);
  switch (pid = fork()) {
  case -1:
    return -1;
  case 0:
    _exit(execve(path,argv,envp));
  }
  if (mode == P_NOWAIT)
    return pid;
  while (wait(&status) != pid);
  /* FIXME: need to extract just exit code for DOS compat */
  return status;
}

int spawnv(int mode,const char *path,const char * const *argv) {
  return spawnve(mode,path,argv,environ);
}

int spawnl(int mode,const char *path,const char *arg0,MORE) {
  return spawnve(mode,path,&arg0,environ);
}

int spawnle(int mode,const char *path,const char *arg0,MORE) {
  const char **envp;
  for (envp = &arg0; *envp; ++envp);
  return spawnve(mode,path,&arg0,envp);
}
