/*
Program:   %M% Revision:  %I% as of %H%
Date:      02/04/91
Author:	   Ed Bond
Function:  stoT.c - String to UNIX time_t.
Copyright (c) 1991 Business Management Systems, Inc.
*/

#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <date.h>
#include <money.h>

/* s can be:  [B]MM/DD/YYYY[B]HH:MM:SS[B] */
/*       or   [B]MMDDYYYY[B]HHMMSS[B] */
/* where [B] is any number of blanks */
time_t stoT(s)
  const char *s;
{
  long t = 0,d = 0;
  struct mmddyy mdy;
  struct tm tm;
  char b[9];
  const char *p = s;

  if (!p) return 0;
  p += strspn(p," ");			/* strip preceding blanks */
  if (strchr(p,'/')) {
    d = stol("ZZ/ZZ/ZZZZ",p,0);
    p = strchr(p,' ');			/* find start of time */
  }
  else {
    int l = 8;
    char *pt = strchr(p,' ');		/* find start of time */
    if (pt && (l=pt-p) > 8) l = 8; 	/* date and time is not separated */
    strncpy(b,p,l)[l] = 0;
    d = atol(b);
    p += l;
  }
  if (p) {
    p += strspn(p," ");
    if (strchr(p,':')) {
      t = stol("ZZ:ZZ:ZZ",p,0);
    }
    else {
      strncpy(b,p,6)[6] = 0;
      t = atol(b);
    }
  }
  if (!d) return 0;
  decode(&mdy,d);
  tm.tm_year = mdy.yy - 1900;
  tm.tm_mon = mdy.mm - 1;
  tm.tm_mday = mdy.dd;
  decode(&mdy,t);
  tm.tm_hour = mdy.mm;
  tm.tm_min = mdy.dd;
  tm.tm_sec = mdy.yy;
  return mktime(&tm);
}
