/*
	return current day of century
*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <date.h>

#define SECSPERHOUR	3600	/* no. of seconds in an hour */
#define SECSPERDAY	86400	/* no. of seconds in a day */
#define DAYSADJ		25203	/* no. of days btween 12/31/1899 - 01/01/1970 */

DATE sysD()
{
  register char *tz = getenv("TZ");	/* get timezone from environment */
  long curtime = time((long *)0);	/* secs since 00:00:00 01/01/1970 */
  if (tz && (tz = strpbrk(tz,"0123456789-"))) {
    curtime -= atol(tz) * SECSPERHOUR;	/* adjust for timezone */
  }
  return curtime / SECSPERDAY + DAYSADJ;	/* convert to days */
}
