/*
Program:   syserr.c Revision:  1.1 as of 4/18/91
Date:      04/06/90
Author:	   Ed Bond
Function:  syserr.c - Report error to stderr.
		      Do longjmp if we are within an "envelope".
Example:   

  if (!(fd = open(filename,"r")))
    syserr(errno,"Can't open %s",filename);

Warning: 

  Do not use this function when running in raw mode.

Copyright (c) 1990 Business Management Systems, Inc.
*/

#include <port.h>
#include <stdarg.h>
#include <stdio.h>
#include <errenv.h>

void syserr(int code,char *fmt,MORE)
{
  const char *prog = "Error";

  if (bmsprog) prog = bmsprog;
  fprintf(stderr,"%s: %d ",prog,code);
  if (fmt) {
    va_list args;
    va_start(args,fmt);
    vfprintf(stderr,fmt,args);
    va_end(args);
  }
  fprintf(stderr,"\n");
  if (errenv) longjmp(errenv->buf,code);
}
