#include <stdlib.h>
#include "tree.h"

/* call user function for nodes of tree in sorted order */

static void tsort_helper(const struct treenode *p,void (*action)(PTR)) {
  if (p->llink)
    tsort_helper(p->llink,action);
  (*action)(p->data);
  if (p->rlink)
    tsort_helper(p->rlink,action);
}

void tsort(TREE T,void (*action)(PTR)) {
  if (T) tsort_helper(T->root,action);
}

/* clear tree and call user function for each node to free user data */
void tclear(TREE *root,void (*clear)(PTR)) {
  TREE T = *root;
  if (T && clear)
    tsort_helper(T->root,clear);	/* free users data */
  /* free our data */
  while (T) {
    *root = T->prev;
    free(T);
    T = *root;
  }
  *root = 0;
}
